/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Groups 管理XMO サーバクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo.Groups;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.sql.*;
import jp.co.ntt.lms.xmo.*;
import jp.co.ntt.lms.xmo.Message.Message;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * Groups 管理XMO サーバクラスです。<BR>
 * XMO基本メソッドを実装し、クライアントからの登録、更新、削除、検索処理
 * 要求をうけそれぞれの処理を行います。<BR>
 * RMIサーバとして動作するためRemoteインタフェースであるXMOインタフェースを実装し、
 * 永続的な起動状態を確保するためjava.rmi.server.UnicastRemoteObjectクラスを継承します。
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class Groups extends UnicastRemoteObject
	implements XMO, GroupsMessage, GroupsTable
{

	//////////////////////////////////////////////////////////////////
	// メソッド名定義
	//////////////////////////////////////////////////////////////////
	/** 登録メソッド名です */
	private static final String METHOD1 = "insert";	// 登録
	/** 更新メソッド名です */
	private static final String METHOD2 = "update";	// 更新
	/** 削除メソッド名です */
	private static final String METHOD3 = "delete";	// 削除
	/** 検索メソッド名です */
	private static final String METHOD4 = "select";	// 検索

	/**
	 * グループテーブルアクセスクラスを保持します
	 */
	private GroupsDataAccess pobjDataAccess = new GroupsDataAccess();

	/**
	 * コンストラクタです。
	 */
	public Groups() throws RemoteException {
		// リモートオブジェクトをエクスポートする
		// java.rmi.server.UnicastRemoteObject の
		// 引数なしのコンストラクタを呼び出す
		super();
	}

	/**
	 * メニュー一覧を返します
	 * @return Vector メニュー一覧
	 */
	public Vector getMenuList(Hashtable htbParam) {
		Vector vecMenuList = new Vector();
		try {
			GroupsEnv objEnv = GroupsEnv.getInstance();
			vecMenuList = objEnv.getMenuList();
		}
		catch( Exception e ) {
			return new Vector();
		}
		return vecMenuList;
	}

	/**
	 * メソッド一覧を返します
	 * @return Vector
	 */
	public Vector getMethodList() {
		Vector vecMethod = new Vector();
		vecMethod.add( METHOD1 );
		vecMethod.add( METHOD2 );
		vecMethod.add( METHOD3 );
		vecMethod.add( METHOD4 );
		return vecMethod;
	}

	/**
	 * デフォルトメニューを返します
	 * @return String
	 */
	public MenuData getDefaultMenu() {
		return null;
	}

	/**
	 * このXMOで定義された、メソッドのクライアント側からの入り口になるメソッドです。
	 * @param strMethodName 実行するメソッド名を指定します
	 * @param htData メソッドで実行するパラメータを指定します<BR>
	 *               なお必要なキーと値は各DAOの処理メソッドの説明を参照して下さい。
	 * @retunr Object 戻り値（さまざまな戻り値に対応するためObject型としてあります)<BR>
	 *                受け取り側では適切な値にキャストする必要があります。
	 */
	public Object execute( String strMethodName, Hashtable htData ) {
		Object objReturn = null;

		if( strMethodName.equals( METHOD1 ) ) {
			objReturn = insert( htData );
		}
		else if( strMethodName.equals( METHOD2 ) ) {
			objReturn = update( htData );
		}
		else if( strMethodName.equals( METHOD3 ) ) {
			objReturn = delete( htData );
		}
		else if( strMethodName.equals( METHOD4 ) ) {
			objReturn = select( htData );
		}

		return objReturn;
	}

	/**
	 * 起動確認（必ずtrueを返す）
	 * @return boolean 必ずtrueが返ります
	 */
	public boolean isLaunch() {
		return true;
	}

	/**
	 * Groupsテーブルへ登録処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの登録処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             GROUP_ID                グループID
	 *             GROUP_NAME              グループ名
	 *             GROUP_TYPE              グループタイプ
	 *             DELETE_FLAG             削除フラグ
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 登録情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector insert( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;

		// 登録処理のパラメータチェックを行います
		String strMessage = insertCheck( htData );
		// パラメータチェックOKのときは登録処理を行う
		if( strMessage.equals( "" ) ) {
			try {
				GroupsData objData = pobjDataAccess.insert( htData );
				vecReturn.add( objData );
			}
			catch( XMOException xe ) {
				// 登録で例外が発生した場合はXMOExceptionからMessageDataを取得する
				objMessage = xe.getMessageData();
			}
		}
		else {
			DebugLog.write( this.getClass(), new Exception(), DebugLog.HIGHT );
			objMessage = getMessageData( strMessage );
		}

		vecReturn.add( 0, objMessage );

		return vecReturn;
	}

	/**
	 * Groupsテーブルへ更新処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの更新処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             GROUP_ID                グループID
	 *             GROUP_NAME              グループ名
	 *             GROUP_TYPE              グループタイプ
	 *             DELETE_FLAG             削除フラグ
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 登録情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector update( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;

		// 更新処理のパラメータチェックを行います
		String strMessage = updateCheck( htData );
		// パラメータチェックOKの時は更新処理を行う
		if( strMessage.equals( "" ) ) {
			try {
				pobjDataAccess.update( htData );
			}
			catch( XMOException xe ) {
				objMessage = xe.getMessageData();
			}
		}
		else {
			DebugLog.write( this.getClass(), new Exception(), DebugLog.HIGHT );
			objMessage = getMessageData( strMessage );
		}
		// メッセージデータオブジェクトの作成
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * Groupsテーブルへ削除処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの削除処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 削除情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector delete( Hashtable htData ) {
		MessageData objMessage = null;
		Vector vecReturn = new Vector();
		try {
			pobjDataAccess.delete( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * Groupsテーブルへ検索処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの検索処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 検索情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納し、２番目移行に
	 *                      AssignmentsDataクラスを格納して返します。)
	 */
	private Vector select( Hashtable htData ) {
		MessageData objMessage = null;
		Vector vecResult = new Vector();
		try {
			vecResult = pobjDataAccess.select( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}

		// 配列の1番目にメッセージデータを格納
		vecResult.add( 0, objMessage );
		return vecResult;
	}

	/**
	 * メッセージオブジェクトを作成します
	 * @param strMessageID メッセージID
	 * @return MessageData メッセージオブジェクト 例外発生時はnullを返します
	 */
	private MessageData getMessageData( String strMessageID) {
		MessageData objMessage = null;
		try {
			objMessage = Message.getInstance().getMessageData( strMessageID, MSG_FIEL_PATH, MSG_FILE_NAME );
		}
		catch( Exception e ) {

		}
		return objMessage;
	}

	/**
	 * 登録処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             GROUP_NAME              グループ名
	 *             GROUP_TYPE              グループタイプ
	 *             DELETE_FLAG             削除フラグ
	 *             FOREING_ID                外部キー
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String insertCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// グループ名のチェック(必須チェックあり)
		strCheck = (String)htbParam.get( GROUP_NAME );
		strMessage = GroupsCheck.checkGroupName( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// グループタイプのチェック(必須チェックあり)
		strCheck = (String)htbParam.get( GROUP_TYPE );
		strMessage = GroupsCheck.checkGroupType( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 削除フラグのチェック(必須チェックあり)
		strCheck = (String)htbParam.get( DELETE_FLAG );
		strMessage = GroupsCheck.checkDeleteFlag( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 外部キーのチェック(必須チェックあり)
		strCheck = (String)htbParam.get( FOREIGN_ID );

		// 外部IDが設定されているまたは画面入力なら
		if(strCheck != null || !BoolAutomaticGrForeignID()){
			strMessage = GroupsCheck.checkForeignID( strCheck, true );
			if( !strMessage.equals( "" ) ) {
				return strMessage;
			}
		}


		// コメントのチェック
		strCheck = (String)htbParam.get( CUSTOM_MSG_DIR );
		strMessage = GroupsCheck.checkCustomMsgDir( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// オブジェクトIDのチェック
		strCheck = (String)htbParam.get( OID );
		strMessage = GroupsCheck.checkOid( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// ＡＤ識別名のチェック
		strCheck = (String)htbParam.get( AD_DN );
		strMessage = GroupsCheck.checkAdDn( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 正常時は空文字を返す
		return "";
	}

	/**
	 * 更新処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             GROUP_ID                グループID
	 *             GROUP_NAME              グループ名
	 *             GROUP_TYPE              グループタイプ
	 *             DELETE_FLAG             削除フラグ
	 *             FOREING_ID               外部キー
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String updateCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// グループIDのチェック
		strCheck = (String)htbParam.get( GROUP_ID );
		strMessage = GroupsCheck.checkGroupID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// グループ名のチェック
		strCheck = (String)htbParam.get( GROUP_NAME );
		strMessage = GroupsCheck.checkGroupName( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// グループタイプのチェック
		strCheck = (String)htbParam.get( GROUP_TYPE );
		strMessage = GroupsCheck.checkGroupType( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 削除フラグのチェック
		strCheck = (String)htbParam.get( DELETE_FLAG );
		strMessage = GroupsCheck.checkDeleteFlag( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 外部キーのチェック
		strCheck = (String)htbParam.get(  FOREIGN_ID );
		strMessage = GroupsCheck.checkForeignID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 外部キーのチェック
		strCheck = (String)htbParam.get(  FOREIGN_ID );
		strMessage = GroupsCheck.checkForeignID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// コメントのチェック
		strCheck = (String)htbParam.get( CUSTOM_MSG_DIR );
		strMessage = GroupsCheck.checkCustomMsgDir( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// オブジェクトIDのチェック
		strCheck = (String)htbParam.get( OID );
		strMessage = GroupsCheck.checkOid( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// ＡＤ識別名のチェック
		strCheck = (String)htbParam.get( AD_DN );
		strMessage = GroupsCheck.checkAdDn( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 正常時は空文字を返す
		return "";
	}

	/**
	 * 外部ID自動採番判断
	 * @return boolen　自動採番: true
	 */
	public boolean BoolAutomaticGrForeignID() {

		boolean boolflag = false;
		// XMS2.ini ファイルにグループPrefixが設定しているかをチェックする
		try{
			Environment objEnv = new Environment();
			String strGetGrPrefix = objEnv.getGrPrefix();

			if (strGetGrPrefix != null){
				boolflag = true;
			}
		}
		catch(Exception ex)
		{
		}
		return 	boolflag;
	}

}

